import React from 'react';

window.g = window.g || {};
export default class ModalAccountBody extends React.Component
{
  render(){
    return (
      <div>
        {this.generateTable()}
      </div>
    );
  }
  generateTable(){
    return(
      <div className="clearfix">
        <table className="table table-striped table-bordered" 
          ref="table"
          cellPadding="0" cellSpacing="0" width="100%">
          <thead>
            <tr className="th_search_w">
              <th></th>
              <th>
                <input type="text" className="form-control" name="name" 
                  placeholder="name" onKeyUp={e=>{
                    this.searchCallback(e);
                  }}/>
              </th>
              <th>
                <input type="text" className="form-control" name="owner_name" 
                  placeholder="owner" onKeyUp={e=>{
                    this.searchCallback(e);
                  }}/>
              </th>
              <th>
                <input type="text" className="form-control" name="type_name" 
                  placeholder="type" onKeyUp={e=>{
                    this.searchCallback(e);
                  }}/>
              </th>
            </tr>
            <tr>
              <th>ID</th>
              <th>Account Name</th>
              <th>Account Owner Alias</th>
              <th>Type</th>
            </tr>
          </thead>
          <tbody></tbody>
        </table>
      </div>
    );
  }
  componentDidMount(){
    this.binTable();
    this.bindNameClick();
  }
  componentWillUnmount(){
    this.t.destroy();
  }
  bindNameClick(){
    $('body').delegate('.account_dlgw .itm_account_name', 'click', (e)=>{
      var $s = $(e.target);
      var id = $s.data('id');
      var text = $s.data('text');
      this.props.setValue({id:id,text:text});
      $('.dlg_div_w .close').trigger('click');
    })
  }
  binTable(){
    var self = this;
    var ajax = {
      url: g.baseUrl + '/account',
      type: 'POST',
      data: function(d){
        d[g.csrfParam] = g.csrfToken;
        if(typeof self.props.options.exceptAccount != 'undefined'){
          d['exceptAccount'] = self.props.options.exceptAccount
        }
        return d;
      }
    };
    var columns = [
      {data: 'id', name:'id',
        orderable:true, searchable:false},
      {data: 'name', name:'name', searchable:true, 
        render: function(data, type, row){
          return '<a data-id="'+ row.id +'" '
            + 'data-text="'+ data +'" '
            + 'class="itm_account_name">'+ data +'</a>';
        }
      },
      {data: 'owner_name', name:'owner_name', searchable:false, orderable:false,},
      {data: 'type_name', name: 'type_name'}
    ];

    this.t = $(this.refs.table).DataTable(Object.assign({}, tableDefaultOptions, {
      ajax: ajax, 
      columns: columns,
      buttons:[],
      dom: '<"row"<"col-sm-12"f>>'
        + '<"row"<"col-sm-12"rt>>'
        + '<"row"<"col-sm-4"l><"col-sm-8 fr"i>>'
        + '<"row"<"col-sm-12"p>>',
    }));
    //搜索框事件绑定
    $('.account_dlgw .dataTables_filter input').off().on('keyup', this.searchCallback.bind(this));
  }
  searchCallback(e){
    var $table = this.t;
    if(e.keyCode == 13){
      var keyword = $('.account_dlgw .dataTables_filter input').val();
      if(keyword!=''){
        $table.search(keyword);
      }
      //console.log(t.column($s.parent().index()))
      $('.account_dlgw .th_search_w .form-control').each(function(i, n){
        var $s = $(n);
        $table.column($s.attr('name') + ':name').search($s.val());
      });
      $table.draw();
    }
  }
  
}